<template>
   <div>
      <div v-show="round.fuelTank > 1" class="fuel-tank">
         <span :style="'width:'+round.fuelTank+'%;'">
            <span :class="start" :style="'animation-delay: 1s; animation-duration: '+round.steps+'s; animation-play-state: '+playPause +';'"></span>
         </span>
      </div>
      <div class="container-robots">
         <div v-for="(robot, index) in robots" class="robot" :class="{'is-active': index == round.currentRobot}"
              @click="setActive(index, robot)" :style="'background:' +robot.bg+';'">
            <p>{{robot.name}}</p>
            <div><span :style="'width:'+robot.maxWay*2+'%;'"></span></div>
            <p>{{robot.maxWay}} sq.km</p>
         </div>
      </div>
   </div>
</template>

<script>
    export default {
        name: "Robots",
        props: [ 'status', 'grid'],
        data: function () {
            return {
                robots: [
                    {
                        name: 'Robot #1',
                        fuelTank: 50,
                        maxWay: '20',
                        bg: 'green',
                        active: false,
                    },
                    {
                        name: 'Robot #2',
                        fuelTank: 50,
                        maxWay: '30',
                        bg: 'red',
                        active: false,
                    },
                    {
                        name: 'Robot #3',
                        fuelTank: 30,
                        maxWay: '45',
                        bg: 'blue',
                        active: false,
                    },
                ],
                round: {
                    currentRobot: null,
                    fuelTank: 0,
                    steps: '0',
                },
                startAnime: true,
            }
        },
        methods: {
            setActive: function (index, robot) {
                this.round.currentRobot = index;
                // this.round.fuelTank = robot.fuelTank;
                this.round.fuelTank = robot.maxWay *2;
                this.round.steps = robot.maxWay * robot.fuelTank / 100;
                this.$emit('stepsRobot', this.round.steps)
                this.$emit('setColorRobot', robot.bg)
            }
        },
        computed: {
            playPause () {
                return this.status ? 'running' : 'paused';
            },
            start () {
              if(this.status == this.startAnime){
                  this.startAnime = !this.startAnime;
                  if(this.grid != this.steps){
                      setTimeout(() =>{
                          this.status = false;
                      }, Number(this.grid)*1110);
                  }
                  return 'active';
              }

            }
        }
    }
</script>

<style scoped>
   .container-robots {
      display: flex;
      justify-content: center;
   }

   .robot {
      width: 30%;
      margin: 40px 1%;
      max-width: 200px;
      cursor: pointer;
      opacity: .5;
      transition: all 0.4s ease;
   }

   .robot.is-active, .robot:hover {
      opacity: 1;
   }

   .robot p {
      color: #fff;
      text-align: center;
      font-weight: bold;
   }

   .robot div {
      height: 20px;
      background-color: #eee;
      margin: 10px 10px 20px;
   }

   .robot div span {
      display: block;
      background-color: yellow;
      height: 20px;
      width: 70%;
   }

   .fuel-tank {
      width: 100%;
      max-width: 500px;
      height: 20px;
      border: 2px solid #000;
      margin: 20px auto;
   }

   .fuel-tank span {
      display: block;
      height: 20px;
   }
   .fuel-tank span span{
      background-color: yellow;
   }
   .fuel-tank span span.active{
      animation: bounce 1s linear both;
   }
   @keyframes bounce {
      0% {
         width: 100%;
      }
      100% {
         width: 0;
      }
   }
</style>